﻿Type=Class
Version=1.95
@EndOfDesignText@
'Class module
Sub Class_Globals

		Dim scanSerial As Serial
		Dim Admin As BluetoothAdmin
		Type NameAndMac (Name As String, Mac As String)
		Dim connectedDevice As NameAndMac
		Dim foundDevices As List
					
					
					Dim retVal As String 
					
					
			
End Sub

'Initializes the object. You can add parameters to this method if needed.
Sub Initialize

End Sub

Sub ScanBatch(passedScanType As String)
	
			If 	connectedDevice.Mac <> Null	Then
			'	localScanTypeObj = daObject.scanTypeObj.ScanBatch
				scanSerial.Connect(connectedDevice.Mac)												
		Else
		
		If Admin.IsInitialized = False Then
			Admin.Initialize("admin")
			scanSerial.Initialize("scanSerial")		
		End If
		
		If Admin.IsEnabled = False Then
				If Admin.Enable = False Then 
					ToastMessageShow("Error enabling Bluetooth adapter.", True)
				Else
				ToastMessageShow("Enabling Bluetooth adapter...", False)
						'the StateChanged event will be soon raised
				End If
		Else			
				'localScanTypeObj = daObject.scanTypeObj.ScanBatch		
				Admin_StateChanged(Admin.STATE_ON, 0)
		End If	
			End If	
		
		'Msgbox(AsyncScanSrv.MsgReceived , "ScanBatch")
		
End Sub



#Region --------------------- Bluetooth Methods & Serial Scan Methods--------------------------------

	Sub Admin_StateChanged (NewState As Int, OldState As Int)
		foundDevices.Initialize
		If Admin.StartDiscovery	= False Then 
			ToastMessageShow("Error starting discovery process.", True)
		Else
			ProgressDialogShow("Searching for devices...")
		End If
	End Sub


	Sub Admin_DeviceFound (Name As String, MacAddress As String)
		Log(Name & ":" & MacAddress)
		Dim nm As NameAndMac
		nm.Name = Name
		nm.Mac = MacAddress
		foundDevices.Add(nm)
		ProgressDialogShow("Searching for devices (~ device found)...".Replace("~", foundDevices.Size))
	End Sub


	Sub Admin_DiscoveryFinished
		ProgressDialogHide
		If foundDevices.Size = 0 Then
			ToastMessageShow("No device found.", True)
		Else
			Dim l As List
			l.Initialize
			For i = 0 To foundDevices.Size - 1
				Dim nm As NameAndMac
				nm = foundDevices.Get(i)
				l.Add(nm.Name)
			Next
			Dim res As Int
			res = InputList(l, "Choose device to connect", -1)
			If res <> DialogResponse.CANCEL Then			
				connectedDevice = foundDevices.Get(res)
				ProgressDialogShow("Trying to connect to: " & connectedDevice.Name & " (" & connectedDevice.Mac & ")")
				scanSerial.Connect(connectedDevice.Mac)
				
			End If
		End If
	End Sub

	' Note scanSerial is Serial Connection While AsyncScanSrv is Service to invoke
	Sub scanSerial_Connected (Success As Boolean)
		ProgressDialogHide
		Log("connected: " & Success)
		If Success = False Then
			Log(LastException.Message)
			ToastMessageShow("Error connecting: " & LastException.Message, True)
		Else
	       ' StartService(AsyncScanSrv)  
		End If
	End Sub

	 
' Sub responds to ALL Scan calls and thusly required flag to determine the caller, I.E. Where to send the results 
	 '*******************************
	Sub NewMsgFromAsyncScanSrv
	
'			Select localScanTypeObj
'			Case daObject.scanTypeObj.ScanBatch
'	    		Msgbox("Scan Batch", AsyncScanSrv.MsgReceived)		
'					Log("Scan Batch" & AsyncScanSrv.MsgReceived)
'					
'			Case daObject.scanTypeObj.scanOrder
'	    		Msgbox("Scan Order", AsyncScanSrv.MsgReceived)		
'					Log("Scan Order" & AsyncScanSrv.MsgReceived)
'					
'			Case daObject.scanTypeObj.scanLocationMap
'	    		Msgbox("Scan LocationMap", AsyncScanSrv.MsgReceived)		
'					Log("Scan LocationMap" & AsyncScanSrv.MsgReceived)	
'					
'			Case daObject.scanTypeObj.scanCurrentLocation
'	    		Msgbox("Scan Current Location", AsyncScanSrv.MsgReceived)		
'					Log("Scan Current Location" & AsyncScanSrv.MsgReceived)	
'					
'			End Select	
'				


			retVal = blueService.strReturnValue
			
  		Msgbox("Scan Current Location", blueService.strReturnValue)
					Log("Scan Current Location" & blueService.strReturnValue)
				
				
				
			
			'  Condition type of Scan  so we know how to respond
	End Sub

#End Region 




